#include <stdio.h>

#include "message.h"

/* void nxp_eval_error(const char *format, ...) */
/* { */
/*     va_list args; */
/*     va_start(args, format); */
/*     g_logv(NXP_EVAL_ERROR_DOMAIN, NXP_LOG_EVAL_ERROR, format, args); */
/*     va_end(args); */
/* } */



void nxp_eval_warning(NxpContext *context, const char *format, ...)
{
    va_list args;
    gchar *str;
    va_start(args, format);
    str = g_strdup_vprintf(format, args);
    if (context->output_handler)
	context->output_handler(str, NXP_MESSAGE_EVAL_WARNING, context);
    else
	printf("Warning: %s\n", str);
    g_free(str);
    va_end(args);
}


/* FIXME: this will not work with multi-threading; for that, TSD
 * (Thread-Specific Data) should be used instead. Luckily, we don't
 * use threads yet, so this is not a problem right now ;) */
/* FIXME: since using TSD incurs a slight performance penalty, it
 * might be better to make nxp_output_message receive a
 * NxpEvalContext. */
/* static NxpOutputHandler output_handler = NULL; */
/* static gpointer output_handler_data = NULL; */


/* void nxp_set_output_handler(NxpOutputHandler func, gpointer data) */
/* { */
/*     output_handler = func; */
/*     output_handler_data = data; */
/* } */


void nxp_output_message(NxpContext *context, const char *format, ...)
{
    va_list args;
    gchar *str;
    va_start(args, format);
    str = g_strdup_vprintf(format, args);
    if (context->output_handler)
	context->output_handler(str, NXP_MESSAGE_PRINT, context);
    else
	printf("%s\n", str);
    g_free(str);
    va_end(args);
}
