/* -*- c -*- */
#include <gsl/gsl_sf_dilog.h>
#include "nxp_kernel.h"
#include "gsl.h"

/*
 * STATUS: Done 
 */

static NxpElement *nxp_gsl_sf_dilog(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_dilog(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}


NxpElement     *
nxp_gsl_sf_complex_dilog_e(NxpElementReal * R, NxpElementReal * THETA, ETC)
{
    gsl_sf_result   RE,
                    IM;
    gsl_sf_complex_dilog_e(nxp_element_r_get_value_as_double(R), nxp_element_r_get_value_as_double(THETA), &RE, &IM);
    GSL_RETURN(nxp_element_complex_new_from_dbl(RE.val + IM.val * I));
}


void
nxp_gsl_sf_dilog_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"dilog");
id = nxp_identifier_new_with_full_path(3,"gsl","dilog", "dilog");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_dilog, NULL, nxp_gsl_sf_dilog, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","dilog", "dilog");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_complex_dilog_e, NULL, nxp_gsl_sf_complex_dilog_e, context, NULL); nxp_identifier_unref(id);
}
