/* -*- c -*- */
#include <gsl/gsl_sf_ellint.h>
#include "nxp_kernel.h"
#include "gsl.h"

/*
 * STATUS: DONE 
 */

static NxpElement *nxp_gsl_sf_ellint_Kcomp(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_Kcomp(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_Ecomp(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_Ecomp(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_F(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_F(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_E(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_E(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_RC(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_RC(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_P(NxpElementReal *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_P(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_D(NxpElementReal *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_D(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_RD(NxpElementReal *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_RD(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_RF(NxpElementReal *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_RF(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_ellint_RJ(NxpElementReal *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3 ,NxpElementReal *arg4, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_ellint_RJ(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg4)) ,GSL_PREC_DOUBLE);
	GSL_RETURN(nxp_element_real_new(ret));
}


void
nxp_gsl_sf_ellint_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"ellint");
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "Kcomp");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_ellint_Kcomp, NULL, nxp_gsl_sf_ellint_Kcomp, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "Ecomp");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_ellint_Ecomp, NULL, nxp_gsl_sf_ellint_Ecomp, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "F");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_ellint_F, NULL, nxp_gsl_sf_ellint_F, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "E");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_ellint_E, NULL, nxp_gsl_sf_ellint_E, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "RC");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_ellint_RC, NULL, nxp_gsl_sf_ellint_RC, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "P");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL_REAL, nxp_gsl_sf_ellint_P, NULL, nxp_gsl_sf_ellint_P, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "D");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL_REAL, nxp_gsl_sf_ellint_D, NULL, nxp_gsl_sf_ellint_D, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "RD");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL_REAL, nxp_gsl_sf_ellint_RD, NULL, nxp_gsl_sf_ellint_RD, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "RF");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL_REAL, nxp_gsl_sf_ellint_RF, NULL, nxp_gsl_sf_ellint_RF, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ellint", "RJ");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL_REAL_REAL, nxp_gsl_sf_ellint_RJ, NULL, nxp_gsl_sf_ellint_RJ, context, NULL); nxp_identifier_unref(id);
}
