/* -*- c -*- */
#include <gsl/gsl_sf_laguerre.h>
#include "nxp_kernel.h"
#include "gsl.h"


static NxpElement *nxp_gsl_sf_laguerre_1(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_laguerre_1(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_laguerre_2(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_laguerre_2(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_laguerre_3(NxpElementReal *arg1 ,NxpElementReal *arg2, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_laguerre_3(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_laguerre_n(NxpElementInt *arg1 ,NxpElementReal *arg2 ,NxpElementReal *arg3, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_laguerre_n(nxp_element_int_get_si(NXP_ELEMENT_INT(arg1), error) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg2)) ,nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg3)));
	GSL_RETURN(nxp_element_real_new(ret));
}


void
nxp_gsl_sf_laguerre_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"laguerre");
id = nxp_identifier_new_with_full_path(3,"gsl","laguerre", "laguerre1");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_laguerre_1, NULL, nxp_gsl_sf_laguerre_1, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","laguerre", "laguerre2");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_laguerre_2, NULL, nxp_gsl_sf_laguerre_2, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","laguerre", "laguerre3");
 nxp_bifunc_define(id, &nxp_prototype__REAL_REAL, nxp_gsl_sf_laguerre_3, NULL, nxp_gsl_sf_laguerre_3, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","laguerre", "laguerreN");
 nxp_bifunc_define(id, &nxp_prototype__INT_REAL_REAL, nxp_gsl_sf_laguerre_n, NULL, nxp_gsl_sf_laguerre_n, context, NULL); nxp_identifier_unref(id);
}
