/* -*- c -*- */
#include <gsl/gsl_sf_log.h>
#include "nxp_kernel.h"
#include "gsl.h"

static NxpElement *nxp_gsl_sf_log(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_log(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_log_abs(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_log_abs(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

NxpElement     *
nxp_gsl_sf_complex_log_e(NxpElementComplex * Z, ETC)
{
    gsl_sf_result   LNR,
                    THETA;
    gsl_sf_complex_log_e(CXREAL(nxp_element_complex_get_value(Z)), CXIMAG(nxp_element_complex_get_value(Z)), &LNR, &THETA);
    GSL_RETURN(nxp_element_complex_new_from_dbl(LNR.val + I * THETA.val));
}
static NxpElement *nxp_gsl_sf_log_1plusx(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_log_1plusx(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}

static NxpElement *nxp_gsl_sf_log_1plusx_mx(NxpElementReal *arg1, ETC)
{
	nxp_real_t ret;
	ret = gsl_sf_log_1plusx_mx(nxp_element_r_get_value_as_double(NXP_ELEMENT_R(arg1)));
	GSL_RETURN(nxp_element_real_new(ret));
}


void
nxp_gsl_sf_log_init(NxpEvalContext * context)
{
    NxpIdentifier  *id;
nxp_name_space_new(context->cwd,"gsl");
nxp_name_space_new(nxp_name_space_find_child(context->cwd,"gsl"),"ln");
id = nxp_identifier_new_with_full_path(3,"gsl","ln", "ln");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_log, NULL, nxp_gsl_sf_log, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ln", "lnAbs");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_log_abs, NULL, nxp_gsl_sf_log_abs, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ln", "ln");
 nxp_bifunc_define(id, &nxp_prototype__COMPLEX, nxp_gsl_sf_complex_log_e, NULL, nxp_gsl_sf_complex_log_e, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ln", "ln1plus");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_log_1plusx, NULL, nxp_gsl_sf_log_1plusx, context, NULL); nxp_identifier_unref(id);
id = nxp_identifier_new_with_full_path(3,"gsl","ln", "ln1plusXminusX");
 nxp_bifunc_define(id, &nxp_prototype__REAL, nxp_gsl_sf_log_1plusx_mx, NULL, nxp_gsl_sf_log_1plusx_mx, context, NULL); nxp_identifier_unref(id);
}
